"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AossLog = void 0;
const express = require('express');
const bodyParser = require('body-parser');
const config_1 = require("../config");
const aws_sdk_1 = __importDefault(require("aws-sdk")); // V2 SDK.
const app = express();
app.use(bodyParser.json({ strict: false }));
aws_sdk_1.default.config.update({ region: 'us-east-1' });
// app.use((err: any, req: any, res: any, next: any) => {
//   if (err instanceof SyntaxError && 'body' in err) {
//     console.log(req);
//     console.log(err);
//     return res.status(400).send({ message: "Invalid request" }); // Bad request
//   }
//   next();
// })
class AossLog {
    constructor() { }
    pushLog(id, correlationId, componentName, severity, createdOn, changesDescription, activityName, subActivityName, outcomeResult, outcomeMessage, actorDisplayName, actoryType, actorId, policyData) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const payLoad = {
                    id, correlationId, componentName, severity, createdOn,
                    changesDescription, activityName, subActivityName,
                    outcomeResult, outcomeMessage, actorDisplayName,
                    actoryType, actorId, policyData
                };
                console.log('Debug:pushLog data', payLoad);
                const sqs = new aws_sdk_1.default.SQS();
                const queueUrl = (0, config_1.Configuration)().aossSqsUrl;
                const params = {
                    MessageBody: JSON.stringify(payLoad),
                    QueueUrl: queueUrl,
                };
                yield sqs.sendMessage(params).promise();
                return;
            }
            catch (error) {
                console.log('Posting log to Aoss failed.', error);
                return;
            }
        });
    }
}
exports.AossLog = AossLog;
